// Diego José Castillo Castellanos   
// Carné: 20764

// Las canciones se obtuvieron de la pagina de internet: https://github.com/robsoncouto/arduino-songs
// 

// Exportar librería de pantalla LCD
#include <LiquidCrystal.h>

// Pines de de comunicación para pantalla LCD
LiquidCrystal lcd(13,12,11,10,9,8);

// Definir la frecuencia de cada una de las notas musicales
#define NOTE_B0  31
#define NOTE_C1  33
#define NOTE_CS1 35
#define NOTE_D1  37
#define NOTE_DS1 39
#define NOTE_E1  41
#define NOTE_F1  44
#define NOTE_FS1 46
#define NOTE_G1  49
#define NOTE_GS1 52
#define NOTE_A1  55
#define NOTE_AS1 58
#define NOTE_B1  62
#define NOTE_C2  65
#define NOTE_CS2 69
#define NOTE_D2  73
#define NOTE_DS2 78
#define NOTE_E2  82
#define NOTE_F2  87
#define NOTE_FS2 93
#define NOTE_G2  98
#define NOTE_GS2 104
#define NOTE_A2  110
#define NOTE_AS2 117
#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637
#define NOTE_F7  2794
#define NOTE_FS7 2960
#define NOTE_G7  3136
#define NOTE_GS7 3322
#define NOTE_A7  3520
#define NOTE_AS7 3729
#define NOTE_B7  3951
#define NOTE_C8  4186
#define NOTE_CS8 4435
#define NOTE_D8  4699
#define NOTE_DS8 4978
#define REST      0

// ------------------------------------------------------------------------------------------------------

//Variables del buzzer y botones.

const int   pinBuzzer  = 5;
const int   pinBoton1  = 2;
const int   pinBoton2  = 3;
const int   pinBoton3  = 4;


// Variables del contador.
int           contador1       = 3;
int           contador2       = 0;

// --------------------------------------------------------------------------------------------------------

void setup() {
  // Inicialización de la LCD.
  lcd.begin(16, 2);
  
  
  // Inicialización de GPIOs.
  pinMode(pinBuzzer, OUTPUT);
  pinMode(pinBoton1, INPUT);
  pinMode(pinBoton2, INPUT);
  pinMode(pinBoton3, INPUT);

}

//--------------------------------------------------------------------------------------------------------

// Ciclo infinito que realiza los cambios de canciones
void loop() {
  cancion();   
  
  if (contador1 == 1) {    
    can1();
    }
  if (contador1 == 2) {    
    can2();
    }
  if (contador1 == 3) {    
    can3();
    }
  delay(300);         

}

// -------------------------------------------------------------------------------------------------------

// Función de pausa
int pausa(){

  int buttonState2 = digitalRead(pinBoton2);

  if (buttonState2 == HIGH){
    if(contador2 == 1) {
      contador2 = 0;
    }
    else {
      contador2 = 1;
    }
  }
}

// --------------------------------------------------------------------------------------------------------

// Esta funcion sirve para ir cambiando de canción con los botones
int cancion() {

  int buttonState1     = digitalRead(pinBoton1);
  int buttonState3     = digitalRead(pinBoton3);  

  if (buttonState1 == HIGH){        
    if (contador1 == 3){         
      contador1 = 1;
      }
    else {
      contador1 ++;
      }
    }

  if (buttonState3 == HIGH){        
    if (contador1 == 1){         
      contador1 = 3;
      }
    else {
      contador1 --;
      }
    }
}

//------------------------------------------------------------------------------------------------------------

// Canción 1 "Pantera Rosa"

void can1(){

  lcd.clear();
  lcd.write("Pantera Rosa");
  
  // Velocidad a la que ira la canción
  int tempo = 120;
  
  int melody[] = {
    NOTE_DS4,8, 
    NOTE_E4,-4, REST,8, NOTE_FS4,8, NOTE_G4,-4, REST,8, NOTE_DS4,8,NOTE_E4,-8, NOTE_FS4,8,  
    NOTE_G4,-8, NOTE_C5,8, NOTE_B4,-8, NOTE_E4,8, NOTE_G4,-8, NOTE_B4,8, NOTE_AS4,2, NOTE_A4,-16,
    NOTE_G4,-16, NOTE_E4,-16, NOTE_D4,-16,NOTE_E4,2, REST,4, REST,8, NOTE_DS4,4, NOTE_E4,-4,
    REST,8, NOTE_FS4,8, NOTE_G4,-4, REST,8, NOTE_DS4,8, NOTE_E4,-8, NOTE_FS4,8,NOTE_G4,-8,
    NOTE_C5,8, NOTE_B4,-8, NOTE_G4,8, NOTE_B4,-8, NOTE_E5,8, NOTE_DS5,1,NOTE_D5,2, 
  };
    
    
    // Duración en segundos de la canción
    
    int notes = sizeof(melody) / sizeof(melody[0]) / 2;
    int wholenote = (60000 * 4) / tempo;
    
    int divisor = 0, noteDuration = 0;
    
    delay(300);

    cancion();

    for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {
      pausa();
      if (contador1 != 1) {
        break;
        }
      if (contador2 == 0) {
        break;
        }

    divisor = melody[thisNote + 1];
    if (divisor > 0) {
      noteDuration = (wholenote) / divisor;
    } else if (divisor < 0) {
      noteDuration = (wholenote) / abs(divisor);
      noteDuration *= 1.5; 
    }
    tone(pinBuzzer, melody[thisNote], noteDuration * 0.9);
    delay(noteDuration);
    noTone(pinBuzzer);
  }
  contador2 = 0;
  delay(300);
}
//--------------------------------------------------------------------------------------------------------

// Cancion 2 "Game of Thrones"

void can2() {

  lcd.clear();
  lcd.write("Game of Thrones");
  
  int tempo = 85;
  
  int melody[] = {
    NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, 
    NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_DS4,16, NOTE_F4,16,
    NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16,
    NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16, NOTE_G4,8, NOTE_C4,8, NOTE_E4,16, NOTE_F4,16,
    NOTE_G4,-4, NOTE_C4,-4, NOTE_DS4,16, NOTE_F4,16, NOTE_G4,4, NOTE_C4,4, NOTE_DS4,16, NOTE_F4,16, 
  };

  int notes = sizeof(melody) / sizeof(melody[0]) / 2;

  int wholenote = (60000 * 4) / tempo;

  int divisor = 0, noteDuration = 0;

   delay(300);

   cancion();
    
    for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {

      pausa();
      if (contador1 != 2) {
        break;
        }
      if (contador2 == 0) {
        break;
        }

    
    divisor = melody[thisNote + 1];
    if (divisor > 0) {
      
      noteDuration = (wholenote) / divisor;
    } else if (divisor < 0) {
      
      noteDuration = (wholenote) / abs(divisor);
      noteDuration *= 1.5; 
    }
    tone(pinBuzzer, melody[thisNote], noteDuration * 0.9);
    delay(noteDuration);
    noTone(pinBuzzer);
  }
  contador2 = 0;
  delay(300);
}


//-------------------------------------------------------------------------------------------------------

// Cancion 3 "We wish you"

void can3() {
  
  lcd.clear();
  lcd.write("We wish you");
  
  int tempo = 140;
  
  int melody[] = { 
    NOTE_C5,4,NOTE_F5,4, NOTE_F5,8, NOTE_G5,8, NOTE_F5,8, NOTE_E5,8,NOTE_D5,4, NOTE_D5,4, NOTE_D5,4,
    NOTE_G5,4, NOTE_G5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F5,8,NOTE_E5,4, NOTE_C5,4, NOTE_C5,4,NOTE_A5,4, 
    NOTE_A5,8, NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8,NOTE_F5,4, NOTE_D5,4, NOTE_C5,8, NOTE_C5,8,NOTE_D5,4, 
    NOTE_G5,4, NOTE_E5,4,NOTE_F5,2,NOTE_C5,4, NOTE_F5,4, NOTE_F5,8, NOTE_G5,8, NOTE_F5,8, NOTE_E5,8,
    NOTE_D5,4, NOTE_D5,4, NOTE_D5,4,NOTE_G5,4, NOTE_G5,8, NOTE_A5,8, NOTE_G5,8, NOTE_F5,8,
    NOTE_E5,4, NOTE_C5,4, NOTE_C5,4,NOTE_A5,4, NOTE_A5,8, NOTE_AS5,8, NOTE_A5,8, NOTE_G5,8,NOTE_F5,4,
    NOTE_D5,4, NOTE_C5,8, NOTE_C5,8,NOTE_D5,4, NOTE_G5,4, NOTE_E5,4,NOTE_F5,2, NOTE_C5,4,
    };


  int notes = sizeof(melody) / sizeof(melody[0]) / 2;

  int wholenote = (60000 * 4) / tempo;

  int divisor = 0, noteDuration = 0;

  delay(300);

  cancion();

  for (int thisNote = 0; thisNote < notes * 2; thisNote = thisNote + 2) {

    pausa();
      if (contador1 != 3) {
        break;
        }
      if (contador2 == 0) {
        break;
        }

    divisor = melody[thisNote + 1];
    if (divisor > 0) {
      noteDuration = (wholenote) / divisor;
    } else if (divisor < 0) {
      noteDuration = (wholenote) / abs(divisor);
      noteDuration *= 1.5; 
    }

    tone(pinBuzzer, melody[thisNote], noteDuration * 0.9);
    delay(noteDuration);
    noTone(pinBuzzer);
  }
  contador2 = 0;
  delay(300); 
}

// ------------------------------------------------------------------------------------------------------


  
